#ifndef ACTPROXY_H
#define ACTPROXY_H

#include <RpcProxy.h>

typedef void(*pEmtpyFunction)(void);
typedef HRESULT(WINAPI *fpDllCanUnloadNow)(void);
typedef HRESULT(WINAPI *fpDllGetClassObject)(const IID *const rclsid, const IID *const riid, LPVOID *ppv);
typedef HRESULT(WINAPI *fpDllRegisterServer)(void);
typedef HRESULT(WINAPI *fpDllUnregisterServer)(void);
typedef void (RPC_ENTRY *fpGetProxyDllInfo)(const ProxyFileInfo ***pInfo, const CLSID **pId);
      


typedef struct _ACTPROXY
{
	fpDllCanUnloadNow pDllCanUnloadNow;
	fpDllGetClassObject pDllGetClassObject;
	fpDllRegisterServer pDllRegisterServer;
	fpDllUnregisterServer pDllUnregisterServer;
	fpGetProxyDllInfo pGetProxyDllInfo;
	
} ACTPROXY, *PACTPROXY;


ACTPROXY trampoline;
HANDLE hLog;
#endif