#include <Windows.h>
#include "json.h"


int main(int argc, char* argv[])
{

	/* 1] prepare a runtime */
	DYNAMIC_LOADER_STRINGS moduleLoaderStrings =
	{
		{ 'k', 'e', 'r', 'n', 'e', 'l', '3', '2', 0x0 },
		{ 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
		{ 'E', 'x', 'p', 'a', 'n', 'd', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'S', 't', 'r', 'i', 'n', 'g', 's', 'A', 0x0 },
		{ 'F', 'i', 'n', 'd', 'C', 'l', 'o', 's', 'e', 0x0 },
		{ 'F', 'i', 'n', 'd', 'F', 'i', 'r', 's', 't', 'F', 'i', 'l', 'e', 'A', 0x0 },
		{ 'F', 'i', 'n', 'd', 'N', 'e', 'x', 't', 'F', 'i', 'l', 'e', 'A', 0x0 },
		{ 'F', 'r', 'e', 'e', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 0x0 },
		{ 'G', 'e', 't', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },
		{ 'G', 'e', 't', 'D', 'r', 'i', 'v', 'e', 'T', 'y', 'p', 'e', 'A', 0x0 },
		{ 'G', 'e', 't', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'A', 0x0 },
		{ 'G', 'e', 't', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'W', 0x0 },
		{ 'G', 'e', 't', 'L', 'a', 's', 't', 'E', 'r', 'r', 'o', 'r', 0x0 },
		{ 'G', 'e', 't', 'P', 'r', 'o', 'c', 'A', 'd', 'd', 'r', 'e', 's', 's', 0x0 },
		{ 'G', 'e', 't', 'S', 'y', 's', 't', 'e', 'm', 'T', 'i', 'm', 'e', 'A', 's', 'F', 'i', 'l', 'e', 'T', 'i', 'm', 'e', 0x0 },
		{ 'G', 'e', 't', 'T', 'i', 'c', 'k', 'C', 'o', 'u', 'n', 't', 0x0 },
		{ 'L', 'o', 'c', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
		{ 'L', 'o', 'a', 'd', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 'A', 0x0 },
		{ 'L', 'o', 'c', 'a', 'l', 'F', 'r', 'e', 'e', 0x0 },
		{ 'L', 'o', 'c', 'a', 'l', 'R', 'e', 'A', 'l', 'l', 'o', 'c', 0x0 },
		{ 'O', 'u', 't', 'p', 'u', 't', 'D', 'e', 'b', 'u', 'g', 'S', 't', 'r', 'i', 'n', 'g', 'A', 0x0 },
		{ 'S', 'l', 'e', 'e', 'p', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 'E', 'x', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'F', 'r', 'e', 'e', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'P', 'r', 'o', 't', 'e', 'c', 't', 0x0 },
		{ 'a', 'd', 'v', 'a', 'p', 'i', '3', '2', 0x0 },
		{ 'C', 'o', 'n', 'v', 'e', 'r', 't', 'S', 'i', 'd', 'T', 'o', 'S', 't', 'r', 'i', 'n', 'g', 'S', 'i', 'd', 'A', 0x0 },
		{ 'G', 'e', 't', 'T', 'o', 'k', 'e', 'n', 'I', 'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'o', 'n', 0x0 },
		{ 'O', 'p', 'e', 'n', 'P', 'r', 'o', 'c', 'e', 's', 's', 'T', 'o', 'k', 'e', 'n', 0x0 },
		{ 'm', 's', 'v', 'c', 'r', 't', 0x0 },
		{ '_', 'c', 'l', 'o', 's', 'e', 0x0 },
		{ 'i', 's', 'd', 'i', 'g', 'i', 't', 0x0 },
		{ 'i', 's', 's', 'p', 'a', 'c', 'e', 0x0 },
		{ '_', 'i', 't', 'o', 'a', '_', 's', 0x0 },
		{ '_', 'i', 't', 'o', 'w', '_', 's', 0x0 },
		{ 'm', 'e', 'm', 'c', 'm', 'p', 0x0 },
		{ 'm', 'e', 'm', 'c', 'p', 'y', 0x0 },
		{ 'm', 'e', 'm', 'c', 'p', 'y', '_', 's', 0x0 },
		{ 'm', 'e', 'm', 's', 'e', 't', 0x0 },
		{ '_', 'o', 'p', 'e', 'n', 0x0 },
		{ 'r', 'a', 'n', 'd', 0x0 },
		{ '_', 'r', 'e', 'a', 'd', 0x0 },
		{ '_', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', '_', 's', 0x0 },
		{ '_', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 's', 'r', 'a', 'n', 'd', 0x0 },
		{ 's', 't', 'r', 'c', 'm', 'p', 0x0 },
		{ '_', 's', 't', 'r', 'd', 'u', 'p', 0x0 },
		{ 's', 't', 'r', 'l', 'e', 'n', 0x0 },
		{ 's', 't', 'r', 'r', 'c', 'h', 'r', 0x0 },
		{ 's', 's', 'c', 'a', 'n', 'f', 0x0 },
		{ 's', 's', 'c', 'a', 'n', 'f', '_', 's', 0x0 },
		{ 's', 't', 'r', 'c', 'a', 't', '_', 's', 0x0 },
		{ 's', 't', 'r', 'c', 'h', 'r', 0x0 },
		{ 's', 't', 'r', 'n', 'c', 'm', 'p', 0x0 },
		{ '_', 's', 't', 'r', 'n', 'i', 'c', 'm', 'p', 0x0 },
		{ 's', 't', 'r', 't', 'o', 'd', 0x0 },
		{ 's', 'w', 'p', 'r', 'i', 'n', 't', 'f', '_', 's', 0x0 },
		{ 't', 'i', 'm', 'e', 0x0 },
		{ '_', 'v', 's', 'c', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 'v', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 'v', 's', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 'w', 'c', 's', 'c', 'a', 't', '_', 's', 0x0 },
		{ 'w', 'c', 's', 'c', 'p', 'y', '_', 's', 0x0 },
		{ 'w', 'c', 's', 'l', 'e', 'n', 0x0 },
		{ '_', 'w', 'r', 'i', 't', 'e', 0x0 },
		{ '_', 'w', 't', 'o', 'i', 0x0 },
		{ 'W', 'i', 'n', 'h', 't', 't', 'p', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'C', 'o', 'n', 'n', 'e', 'c', 't', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'G', 'e', 't', 'I', 'E', 'P', 'r', 'o', 'x', 'y', 'C', 'o', 'n', 'f', 'i', 'g', 'F', 'o', 'r', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'U', 's', 'e', 'r', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'G', 'e', 't', 'P', 'r', 'o', 'x', 'y', 'F', 'o', 'r', 'U', 'r', 'l', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 'R', 'e', 'q', 'u', 'e', 's', 't', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'Q', 'u', 'e', 'r', 'y', 'H', 'e', 'a', 'd', 'e', 'r', 's', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'R', 'e', 'a', 'd', 'D', 'a', 't', 'a', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'R', 'e', 'c', 'e', 'i', 'v', 'e', 'R', 'e', 's', 'p', 'o', 'n', 's', 'e', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 'n', 'd', 'R', 'e', 'q', 'u', 'e', 's', 't', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 't', 'O', 'p', 't', 'i', 'o', 'n', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 't', 'T', 'i', 'm', 'e', 'o', 'u', 't', 's', 0x0 },
		{ 'W', 's', '2', '_', '3', '2', 0x0 },
		{ 'g', 'e', 't', 'h', 'o', 's', 't', 'b', 'y', 'n', 'a', 'm', 'e', 0x0 },
		{ 'i', 'n', 'e', 't', '_', 'a', 'd', 'd', 'r', 0x0 },
		{ 'i', 'n', 'e', 't', '_', 'n', 't', 'o', 'a', 0x0 },
		{ 'n', 't', 'o', 'h', 'l', 0x0 },
		{ 'W', 'S', 'A', 'C', 'l', 'e', 'a', 'n', 'u', 'p', 0x0 },
		{ 'W', 'S', 'A', 'S', 't', 'a', 'r', 't', 'u', 'p', 0x0 },
	};


	INIT_FUNCTIONPOINTERS init;
	init.fpGetProcAddress = GetProcAddress;
	init.fpLoadLibraryA = LoadLibraryA;
	init.fpLocalAlloc = LocalAlloc;
	init.fpLocalFree = LocalFree;

	PRUNTIME pRuntime = NULL;
	RuntimeInit(&pRuntime, &moduleLoaderStrings, &init);

	/*LPVOID lpTest = pRuntime->pKernel32->fpVirtualAlloc(NULL, 0x1000, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	pRuntime->pKernel32->fpVirtualFree(lpTest, 0, MEM_RELEASE);

	lpTest = pRuntime->pAllocators->fpSalloc(pRuntime, 0x100);
	pRuntime->pAllocators->fpSfree(pRuntime, lpTest);*/

	
	/* 2] module specific stuff */
	PMODULE_SPECIFIC_DATA pConfigurationSpecificData = (PMODULE_SPECIFIC_DATA)malloc(sizeof(MODULE_SPECIFIC_DATA));

	pRuntime->pModuleSpecificData[INDEX_CONFIGURATION] = pConfigurationSpecificData;

	PVARIABLES_CONFIGURATION pVariablesConfiguration = (PVARIABLES_CONFIGURATION)malloc(sizeof(VARIABLES_CONFIGURATION));

	pRuntime->pModuleSpecificData[INDEX_CONFIGURATION]->lpVariables = pVariablesConfiguration;

	STRINGS_CONFIGURATION configurationStrings =
	{
		{ '[', 0x0 },
		{ 'c', 'o', 'n', 't', 'i', 'n', 'u', 'e', 0x0 },
		{ '}', 0x0 },
		{ ',', 0x0 },
		{ '\\', '/', 0x0 },
		{ '%', '.', '1', '7', 'g', 0x0 },
		{ '%', 'l', 'l', 'd', 0x0 },
		{ ']', 0x0 },
		{ 'n', 'u', 'm', 'b', 'e', 'r', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', 0x0 },
		{ 'b', 'u', 'f', 'f', 'e', 'r', ' ', 's', 'i', 'z', 'e', ' ', 'o', 'v', 'e', 'r', 'f', 'l', 'o', 'w', 0x0 },
		{ '\\', 'u', '0', '0', '%', 'c', '%', 'c', 0x0 },
		{ 'o', 'b', 'j', 'e', 'c', 't', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'y', ' ', 'n', 'a', 'm', 'e', ' ', 's', 'e', 'p', 'a', 'r', 'a', 't', 'o', 'r', ' ', '\'', ':', '\'', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', 0x0 },
		{ '"', 0x0 },
		{ 'n', 'u', 'l', 'l', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', 0x0 },
		{ 't', 'r', 'u', 'e', 0x0 },
		{ '"', ':', 0x0 },
		{ 's', 'u', 'c', 'c', 'e', 's', 's', 0x0 },
		{ '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.', '+', '-', 'e', 'E', 0x0 },
		{ '\\', 'n', 0x0 },
		{ ' ', ']', 0x0 },
		{ '\\', 'f', 0x0 },
		{ '\\', 'b', 0x0 },
		{ '\\', 't', 0x0 },
		{ 'b', 'o', 'o', 'l', 'e', 'a', 'n', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', 0x0 },
		{ '\\n', 0x0 },
		{ ' ', '-', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', 0x0 },
		{ 'f', 'a', 'l', 's', 'e', 0x0 },
		{ '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'A', 'B', 'C', 'D', 'E', 'F', 0x0 },
		{ '', 0x0 },
		{ '', 0x0 },
		{ '"', ':', ' ', 0x0 },
		{ '	', 0x0 },
		{ 'n', 'u', 'l', 'l', 0x0 },
		{ '\r', 0x0 },
		{ ' ', 0x0 },
		{ 'N', 'a', 'N', 0x0 },
		{ '-', 'I', 'n', 'f', 'i', 'n', 'i', 't', 'y', 0x0 },
		{ ' ', '}', 0x0 },
		{ '%', 'l', 'f', 0x0 },
		{ 'a', 'r', 'r', 'a', 'y', ' ', 'v', 'a', 'l', 'u', 'e', ' ', 's', 'e', 'p', 'a', 'r', 'a', 't', 'o', 'r', ' ', '\'', ', ', '\'', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', 0x0 },
		{ '{', 0x0 },
		{ 'U', 'n', 'k', 'n', 'o', 'w', 'n', ' ', 'e', 'r', 'r', 'o', 'r', 0x0 },
		{ '\n', 0x0 },
		{ 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'e', 'n', 'd', ' ', 'o', 'f', ' ', 'd', 'a', 't', 'a', 0x0 },
		{ 'q', 'u', 'o', 't', 'e', 'd', ' ', 'o', 'b', 'j', 'e', 'c', 't', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'y', ' ', 'n', 'a', 'm', 'e', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', 0x0 },
		{ ' ', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', 0x0 },
		{ 'n', 'e', 's', 't', 'i', 'n', 'g', ' ', 't', 'o', 'o', ' ', 'd', 'e', 'e', 'p', 0x0 },
		{ 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'c', 'h', 'a', 'r', 'a', 'c', 't', 'e', 'r', 0x0 },
		{ 'C', 0x0 },
		{ '\r', 0x0 },
		{ 'I', 'n', 'f', 'i', 'n', 'i', 't', 'y', 0x0 },

		/* manual */
		{ '\\', '"', 0x0 },
		{ '\\', '\\', 0x0 }

	};
	pRuntime->pModuleSpecificData[INDEX_CONFIGURATION]->lpStrings = &configurationStrings;


	/* main */
	json_object *config = NULL;
	config = json_object_from_file(pRuntime, argv[1]);


	return 0;
}