#include <Windows.h>

#include "Events.h"

#include "..\Runtime\Runtime.h"

#include <intrin.h>

#include "..\common\uthash_runtime.h"

#pragma comment( linker, "/subsystem:console" )
#pragma section("loader", read,execute)
#pragma code_seg("loader")

void* test_callback(PRUNTIME pRuntime, void* args)
{
	OUTPUTDEBUG("[*] callback: %s\n", (LPSTR)args);
	
	return NULL;
}

void go(){
	
	/* 1] prepare a runtime */
	DYNAMIC_LOADER_STRINGS moduleLoaderStrings =
	{
		{ 'k', 'e', 'r', 'n', 'e', 'l', '3', '2', 0x0 },
		{ 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
		{ 'C', 'r', 'e', 'a', 't', 'e', 'F', 'i', 'l', 'e', 'A', 0x0 },
		{ 'C', 'r', 'e', 'a', 't', 'e', 'P', 'i', 'p', 'e', 0x0 },
		{ 'D', 'e', 'l', 'e', 't', 'e', 'F', 'i', 'l', 'e', 0x0 },
		{ 'E', 'n', 't', 'e', 'r', 'C', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'S', 'e', 'c', 't', 'i', 'o', 'n', 0x0 },
		{ 'E', 'x', 'p', 'a', 'n', 'd', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'S', 't', 'r', 'i', 'n', 'g', 's', 'A', 0x0 },
		{ 'F', 'i', 'n', 'd', 'C', 'l', 'o', 's', 'e', 0x0 },
		{ 'F', 'i', 'n', 'd', 'F', 'i', 'r', 's', 't', 'F', 'i', 'l', 'e', 'A', 0x0 },
		{ 'F', 'i', 'n', 'd', 'N', 'e', 'x', 't', 'F', 'i', 'l', 'e', 'A', 0x0 },
		{ 'F', 'l', 'u', 's', 'h', 'F', 'i', 'l', 'e', 'B', 'u', 'f', 'f', 'e', 'r', 's', 0x0 },
		{ 'F', 'r', 'e', 'e', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 0x0 },
		{ 'G', 'e', 't', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },
		{ 'G', 'e', 't', 'D', 'r', 'i', 'v', 'e', 'T', 'y', 'p', 'e', 'A', 0x0 },
		{ 'G', 'e', 't', 'F', 'i', 'l', 'e', 'S', 'i', 'z', 'e', 0x0 },
		{ 'G', 'e', 't', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'A', 0x0 },
		{ 'G', 'e', 't', 'E', 'n', 'v', 'i', 'r', 'o', 'n', 'm', 'e', 'n', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'W', 0x0 },
		{ 'G', 'e', 't', 'L', 'a', 's', 't', 'E', 'r', 'r', 'o', 'r', 0x0 },
		{ 'G', 'e', 't', 'P', 'r', 'o', 'c', 'A', 'd', 'd', 'r', 'e', 's', 's', 0x0 },
		{ 'G', 'e', 't', 'S', 'y', 's', 't', 'e', 'm', 'T', 'i', 'm', 'e', 'A', 's', 'F', 'i', 'l', 'e', 'T', 'i', 'm', 'e', 0x0 },
		{ 'G', 'e', 't', 'T', 'i', 'c', 'k', 'C', 'o', 'u', 'n', 't', 0x0 },
		{ 'I', 'n', 'i', 't', 'i', 'a', 'l', 'i', 'z', 'e', 'C', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'S', 'e', 'c', 't', 'i', 'o', 'n', 0x0 },
		{ 'L', 'e', 'a', 'v', 'e', 'C', 'r', 'i', 't', 'i', 'c', 'a', 'l', 'S', 'e', 'c', 't', 'i', 'o', 'n', 0x0 },
		{ 'L', 'o', 'c', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
		{ 'L', 'o', 'a', 'd', 'L', 'i', 'b', 'r', 'a', 'r', 'y', 'A', 0x0 },
		{ 'L', 'o', 'c', 'a', 'l', 'F', 'r', 'e', 'e', 0x0 },
		{ 'L', 'o', 'c', 'a', 'l', 'R', 'e', 'A', 'l', 'l', 'o', 'c', 0x0 },
		{ 'O', 'u', 't', 'p', 'u', 't', 'D', 'e', 'b', 'u', 'g', 'S', 't', 'r', 'i', 'n', 'g', 'A', 0x0 },
		{ 'R', 'e', 'a', 'd', 'F', 'i', 'l', 'e', 0x0 },
		{ 'S', 'l', 'e', 'e', 'p', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'A', 'l', 'l', 'o', 'c', 'E', 'x', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'F', 'r', 'e', 'e', 0x0 },
		{ 'V', 'i', 'r', 't', 'u', 'a', 'l', 'P', 'r', 'o', 't', 'e', 'c', 't', 0x0 },
		{ 'W', 'a', 'i', 't', 'F', 'o', 'r', 'S', 'i', 'n', 'g', 'l', 'e', 'O', 'b', 'j', 'e', 'c', 't', 0x0 },
		{ 'W', 'r', 'i', 't', 'e', 'F', 'i', 'l', 'e', 0x0 },
		{ 'a', 'd', 'v', 'a', 'p', 'i', '3', '2', 0x0 },
		{ 'C', 'o', 'n', 'v', 'e', 'r', 't', 'S', 'i', 'd', 'T', 'o', 'S', 't', 'r', 'i', 'n', 'g', 'S', 'i', 'd', 'A', 0x0 },
		{ 'G', 'e', 't', 'T', 'o', 'k', 'e', 'n', 'I', 'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'o', 'n', 0x0 },
		{ 'O', 'p', 'e', 'n', 'P', 'r', 'o', 'c', 'e', 's', 's', 'T', 'o', 'k', 'e', 'n', 0x0 },
		{ 'm', 's', 'v', 'c', 'r', 't', 0x0 },
		{ '_', 'b', 'e', 'g', 'i', 'n', 't', 'h', 'r', 'e', 'a', 'd', 'e', 'x', 0x0 },
		{ '_', 'c', 'l', 'o', 's', 'e', 0x0 },
		{ 'i', 's', 'd', 'i', 'g', 'i', 't', 0x0 },
		{ 'i', 's', 's', 'p', 'a', 'c', 'e', 0x0 },
		{ '_', 'i', 't', 'o', 'a', '_', 's', 0x0 },
		{ '_', 'i', 't', 'o', 'w', '_', 's', 0x0 },
		{ 'm', 'e', 'm', 'c', 'm', 'p', 0x0 },
		{ 'm', 'e', 'm', 'c', 'p', 'y', 0x0 },
		{ 'm', 'e', 'm', 'c', 'p', 'y', '_', 's', 0x0 },
		{ 'm', 'e', 'm', 's', 'e', 't', 0x0 },
		{ '_', 'o', 'p', 'e', 'n', 0x0 },
		{ 'r', 'a', 'n', 'd', 0x0 },
		{ '_', 'r', 'e', 'a', 'd', 0x0 },
		{ '_', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', '_', 's', 0x0 },
		{ '_', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 's', 'r', 'a', 'n', 'd', 0x0 },
		{ 's', 't', 'r', 'c', 'm', 'p', 0x0 },
		{ '_', 's', 't', 'r', 'd', 'u', 'p', 0x0 },
		{ 's', 't', 'r', 'l', 'e', 'n', 0x0 },
		{ 's', 't', 'r', 'r', 'c', 'h', 'r', 0x0 },
		{ 's', 's', 'c', 'a', 'n', 'f', 0x0 },
		{ 's', 's', 'c', 'a', 'n', 'f', '_', 's', 0x0 },
		{ 's', 't', 'r', 'c', 'a', 't', '_', 's', 0x0 },
		{ 's', 't', 'r', 'c', 'h', 'r', 0x0 },
		{ 's', 't', 'r', 'n', 'c', 'p', 'y', '_', 's', 0x0 },
		{ 's', 't', 'r', 'n', 'c', 'm', 'p', 0x0 },
		{ '_', 's', 't', 'r', 'n', 'i', 'c', 'm', 'p', 0x0 },
		{ 's', 't', 'r', 't', 'o', 'd', 0x0 },
		{ 's', 'w', 'p', 'r', 'i', 'n', 't', 'f', '_', 's', 0x0 },
		{ 't', 'i', 'm', 'e', 0x0 },
		{ 't', 'o', 'u', 'p', 'p', 'e', 'r', 0x0 },
		{ '_', 'v', 's', 'c', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 'v', 's', 'n', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 'v', 's', 'p', 'r', 'i', 'n', 't', 'f', 0x0 },
		{ 'w', 'c', 's', 'c', 'a', 't', '_', 's', 0x0 },
		{ 'w', 'c', 's', 'c', 'p', 'y', '_', 's', 0x0 },
		{ 'w', 'c', 's', 'l', 'e', 'n', 0x0 },
		{ '_', 'w', 'r', 'i', 't', 'e', 0x0 },
		{ '_', 'w', 't', 'o', 'i', 0x0 },
		{ 'W', 'i', 'n', 'h', 't', 't', 'p', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'C', 'l', 'o', 's', 'e', 'H', 'a', 'n', 'd', 'l', 'e', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'C', 'o', 'n', 'n', 'e', 'c', 't', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'G', 'e', 't', 'I', 'E', 'P', 'r', 'o', 'x', 'y', 'C', 'o', 'n', 'f', 'i', 'g', 'F', 'o', 'r', 'C', 'u', 'r', 'r', 'e', 'n', 't', 'U', 's', 'e', 'r', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'G', 'e', 't', 'P', 'r', 'o', 'x', 'y', 'F', 'o', 'r', 'U', 'r', 'l', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'O', 'p', 'e', 'n', 'R', 'e', 'q', 'u', 'e', 's', 't', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'Q', 'u', 'e', 'r', 'y', 'H', 'e', 'a', 'd', 'e', 'r', 's', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'R', 'e', 'a', 'd', 'D', 'a', 't', 'a', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'R', 'e', 'c', 'e', 'i', 'v', 'e', 'R', 'e', 's', 'p', 'o', 'n', 's', 'e', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 'n', 'd', 'R', 'e', 'q', 'u', 'e', 's', 't', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 't', 'O', 'p', 't', 'i', 'o', 'n', 0x0 },
		{ 'W', 'i', 'n', 'H', 't', 't', 'p', 'S', 'e', 't', 'T', 'i', 'm', 'e', 'o', 'u', 't', 's', 0x0 },
		{ 'W', 's', '2', '_', '3', '2', 0x0 },
		{ 'g', 'e', 't', 'h', 'o', 's', 't', 'b', 'y', 'n', 'a', 'm', 'e', 0x0 },
		{ 'i', 'n', 'e', 't', '_', 'a', 'd', 'd', 'r', 0x0 },
		{ 'i', 'n', 'e', 't', '_', 'n', 't', 'o', 'a', 0x0 },
		{ 'n', 't', 'o', 'h', 'l', 0x0 },
		{ 'W', 'S', 'A', 'C', 'l', 'e', 'a', 'n', 'u', 'p', 0x0 },
		{ 'W', 'S', 'A', 'S', 't', 'a', 'r', 't', 'u', 'p', 0x0 },
		{ 'O', 'l', 'e', 'A', 'u', 't', '3', '2', 0x0 },
		{ 'S', 'y', 's', 'A', 'l', 'l', 'o', 'c', 'S', 't', 'r', 'i', 'n', 'g', 0x0 },
		{ 'S', 'y', 's', 'F', 'r', 'e', 'e', 'S', 't', 'r', 'i', 'n', 'g', 0x0 },
		{ 'V', 'a', 'r', 'i', 'a', 'n', 't', 'C', 'l', 'e', 'a', 'r', 0x0 },
		{ 'V', 'a', 'r', 'i', 'a', 'n', 't', 'I', 'n', 'i', 't', 0x0 },
		{ 'O', 'l', 'e', '3', '2', 0x0 },
		{ 'C', 'o', 'C', 'r', 'e', 'a', 't', 'e', 'I', 'n', 's', 't', 'a', 'n', 'c', 'e', 0x0 },
		{ 'C', 'o', 'I', 'n', 'i', 't', 'i', 'a', 'l', 'i', 'z', 'e', 'E', 'x', 0x0 },
		{ 'C', 'o', 'I', 'n', 'i', 't', 'i', 'a', 'l', 'i', 'z', 'e', 'S', 'e', 'c', 'u', 'r', 'i', 't', 'y', 0x0 },
		{ 'C', 'o', 'S', 'e', 't', 'P', 'r', 'o', 'x', 'y', 'B', 'l', 'a', 'n', 'k', 'e', 't', 0x0 },
		{ 'C', 'o', 'U', 'n', 'i', 'n', 'i', 't', 'i', 'a', 'l', 'i', 'z', 'e', 0x0 },
	};


	INIT_FUNCTIONPOINTERS init;
	init.fpGetProcAddress = GetProcAddress;
	init.fpLoadLibraryA = LoadLibraryA;
	init.fpLocalAlloc = LocalAlloc;
	init.fpLocalFree = LocalFree;

	PRUNTIME pRuntime = NULL;
	RuntimeInit(&pRuntime, &moduleLoaderStrings, &init);

	/* event variables */
	PMODULE_SPECIFIC_DATA peventSpecificData = (PMODULE_SPECIFIC_DATA)malloc(sizeof(MODULE_SPECIFIC_DATA));

	pRuntime->pModuleSpecificData[INDEX_EVENTS] = peventSpecificData;

	PVARIABLES_EVENTS pVariablesevent = (PVARIABLES_EVENTS)malloc(sizeof(VARIABLES_EVENTS));
	pRuntime->pModuleSpecificData[INDEX_EVENTS]->lpVariables = pVariablesevent;


	/* event strings */
	STRINGS_EVENTS eventStrings =
	{
		{ '%', 'S', 0x0 },
		{ 'n', 'a', 'm', 'e', ' ', '%', 'S', '\n', 0x0 },
		{ 'p', 'S', 'i', 'n', 'k', ' ', '%', 'p', '	', 0x0 },
		{ 'T', 'a', 'r', 'g', 'e', 't', 'I', 'n', 's', 't', 'a', 'n', 'c', 'e', 0x0 },
		{ 'N', 'a', 'm', 'e', ' ', ':', ' ', 0x0 },
		{ 'P', 'r', 'o', 'c', 'e', 's', 's', 'I', 'd', 0x0 },
		{ 'S', 'i', 'n', 'k', 'S', 'e', 't', 'S', 't', 'a', 't', 'u', 's', '\n', 0x0 },
		{ 'E', 'x', 'e', 'c', 'N', 'o', 't', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', 'Q', 'u', 'e', 'r', 'y', 'A', 's', 'y', 'n', 'c', ' ', 'f', 'a', 'i', 'l', 'e', 'd', ' ', 'w', 'i', 't', 'h', ' ', '=', ' ', '0', 'x', '%', 'X', '\n', 0x0 },
		{ '%', 'S', ' ', '%', 'd', '\n',  0x0 },
		{ 'S', 'E', 'L', 'E', 'C', 'T', ' ', '*', ' ', 'F', 'R', 'O', 'M', ' ', 'W', 'i', 'n', '3', '2', '_', 'P', 'r', 'o', 'c', 'e', 's', 's', 0x0 },
		{ 'l', 'o', 'a', 'd', 'e', 'r', 0x0 },
		{ 'e', 'm', 'p', 't', 'y', ' ', 'n', 'a', 'm', 'e', '\n', 0x0 },
		{ 'a', 'd', 'd', 'r', 'e', 'f', ':', ' ', '%', 'd', '\n', 0x0 },
		{ 'e', 'v', 'e', 'n', 't', ' ', 'o', 'c', 'c', 'u', 'r', 'e', 'd', '\n', 0x0 },
		{ 'C', 'r', 'e', 'a', 't', 'e', '\n', 0x0 },
		{ 'C', 'l', 'o', 's', 'e', '\n', 0x0 },
		{ 'C', 'o', 'n', 'n', 'e', 'c', 't', 'e', 'd', '\n', 0x0 },
		{ 'W', 'Q', 'L', 0x0 }, // UNICODE
		{ 'S', 'E', 'L', 'E', 'C', 'T', ' ', '*', ' ', 'F', 'R', 'O', 'M', ' ', ' ', '_', '_', 'I', 'n', 's', 't', 'a', 'n', 'c', 'e', 'C', 'r', 'e', 'a', 't', 'i', 'o', 'n', 'E', 'v', 'e', 'n', 't', ' ', 'W', 'I', 'T', 'H', 'I', 'N', ' ', '1', ' ', 'W', 'H', 'E', 'R', 'E', ' ', 'T', 'a', 'r', 'g', 'e', 't', 'I', 'n', 's', 't', 'a', 'n', 'c', 'e', ' ', 'I', 'S', 'A', ' ', '\'', 'W', 'I', 'n', '3', '2', '_', 'P', 'r', 'o', 'c', 'e', 's', 's', '\'', 0x0 },
		{ 'S', 'E', 'L', 'E', 'C', 'T', ' ', '*', ' ', 'F', 'R', 'O', 'M', ' ', ' ', '_', '_', 'I', 'n', 's', 't', 'a', 'n', 'c', 'e', 'D', 'e', 'l', 'e', 't', 'i', 'o', 'n', 'E', 'v', 'e', 'n', 't', ' ', 'W', 'I', 'T', 'H', 'I', 'N', ' ', '1', ' ', 'W', 'H', 'E', 'R', 'E', ' ', 'T', 'a', 'r', 'g', 'e', 't', 'I', 'n', 's', 't', 'a', 'n', 'c', 'e', ' ', 'I', 'S', 'A', ' ', '\'', 'W', 'I', 'n', '3', '2', '_', 'P', 'r', 'o', 'c', 'e', 's', 's', '\'', 0x0 },
		{ 'N', 'a', 'm', 'e', 0x0 },
		{ 'R', 'O', 'O', 'T', '\\', 'C', 'I', 'M', 'V', '2', 0x0 }, // UNICODE
		{ 00, 00, 00, 00, 00, 00, 00, 00, 0xC0, 00, 00, 00, 00, 00, 00, 0x46 }, // IUnknown
		{ 0x01, 0x78, 0x85, 0x7c, 0x81, 0x73, 0xcf, 0x11, 0x88, 0x4d, 0x00, 0xaa, 0x00, 0x4b, 0x2e, 0x24 }, // IWbemObjectSink
		{ 0x87, 0xa6, 0x12, 0xdc, 0x7f, 0x73, 0xcf, 0x11, 0x88, 0x4d, 0x00, 0xaa, 0x00, 0x4b, 0x2e, 0x24 }, // IWbemLocator
		{ 0x8c, 0xba, 0xfa, 0x1c, 0x23, 0x15, 0xd1, 0x11, 0xad, 0x79, 0x00, 0xc0, 0x4f, 0xd8, 0xfd, 0xff }, // IUnsecuredApartment
		{ 0x81, 0xa6, 0x12, 0xdc, 0x7f, 0x73, 0xcf, 0x11, 0x88, 0x4d, 0x00, 0xaa, 0x00, 0x4b, 0x2e, 0x24 }, // IWbemClassObject
		{ 0x11, 0xf8, 0x90, 0x45, 0x3a, 0x1d, 0xd0, 0x11, 0x89, 0x1f, 0x00, 0xaa, 0x00, 0x4b, 0x2e, 0x24 }, // CLSID_WbemLocator
		{ 0x28, 0x20, 0xbd, 0x49, 0x23, 0x15, 0xd1, 0x11, 0xad, 0x79, 0x00, 0xc0, 0x4f, 0xd8, 0xfd, 0xff }, // CLSID_UnsecuredApartment
	};
	
	pRuntime->pModuleSpecificData[INDEX_EVENTS]->lpStrings = &eventStrings;

	/* a] unique by pid */
	pVariablesevent->pProcessList = NULL;
	API_INITIALIZECRITICALSECTION(&pVariablesevent->pProcessListCriticalSection);

	/* b] unique by name */
	pVariablesevent->pProcessListUniqueByName = NULL;
	API_INITIALIZECRITICALSECTION(&pVariablesevent->pProcessListCriticalSectionUniqueByName);


	pVariablesevent->pMonitoredProcessList = NULL;

	/* 1] fetch initial process list */
	get_process_list(pRuntime);

	/* print list */
	PPROCESS_LIST_ELEMENT tmp_elem, current;
	HASH_ITER(pRuntime, hh, pVariablesevent->pProcessListUniqueByName, current, tmp_elem)
	{
		//OUTPUTDEBUGRUNTIME(pRuntime, "process: %s number of instances: %d\n", current->strProcessName, current->dwNumberOfInstances);

		//HASH_DEL(pRuntime, pVariablesevent->pProcessList, current);
		
		//API_FREE(pRuntime, current);
	}

	/* 2] start process creation/deletion callback */

	start_process_creation_callback(pRuntime);
	start_process_deletion_callback(pRuntime);
	
	
	// test process_addwatch, process_delwatch

	PMONITORED_PROCESS p1;

	//MONITOR_PROCESS.addwatch(pRuntime, onbegin, e, MONITOR_FLAG_NONE, EVENT_PROCESS_P(e)->name);
	p1 = process_addwatch(pRuntime, test_callback, "cal?.exe", 0, "cal?.exe");

	monitored_process_dump(pRuntime);
	//PMONITORED_PROCESS p2 = process_addwatch(pRuntime, NULL, NULL, NULL, "calc.exe");
	//monitored_process_dump(pRuntime);
	PMONITORED_PROCESS p3 = process_addwatch(pRuntime, test_callback, "notepa*", 0, "notepa*");
	monitored_process_dump(pRuntime);

	/*process_delwatch(pRuntime, p1);
	monitored_process_dump(pRuntime);
	process_delwatch(pRuntime, p2);
	monitored_process_dump(pRuntime);
	process_delwatch(pRuntime, p3);
	monitored_process_dump(pRuntime);*/

	API_SLEEP(100000);


	/* cleanup */
	free(peventSpecificData);
	free(pVariablesevent);
}

int main(int argc, char *argcv[])
{
	go();
}