#pragma once
#include <Windows.h>

typedef BOOL(WINAPI *CONVERTSIDTOSTRINGSIDA)(_In_  PSID   Sid, _Out_ LPSTR *StringSid);
typedef BOOL(WINAPI *GETTOKENINFORMATION)(_In_ HANDLE TokenHandle, _In_ TOKEN_INFORMATION_CLASS TokenInformationClass, _Out_opt_ LPVOID TokenInformation, _In_ DWORD TokenInformationLength, _Out_ PDWORD ReturnLength);
typedef BOOL(WINAPI *OPENPROCESSTOKEN)(_In_  HANDLE  ProcessHandle, _In_  DWORD   DesiredAccess, _Out_ PHANDLE TokenHandle);



typedef struct _VTABLE_ADVAPI32
{
	CONVERTSIDTOSTRINGSIDA fpConvertSidToStringSidA;
	GETTOKENINFORMATION fpGetTokenInformation;
	OPENPROCESSTOKEN fpOpenProcessToken;
} VTABLE_ADVAPI32, *PVTABLE_ADVAPI32;
