EXTRN	RuntimeInit:PROC
EXTRN	RuntimeClose:PROC
EXTRN	RuntimeMain:PROC

PUBLIC	RuntimeInitWrapper
PUBLIC  RuntimeCloseWrapper
PUBLIC  RuntimeMainWrapper

RuntimeInitWrapperExport		EQU 00dd171e5f00d0001h
RuntimeCloseWrapperExport		EQU 00dd171e5f00d0002h
RuntimeMainWrapperExport		EQU 00dd171e5f00d0003h

loader	SEGMENT READ EXECUTE

RuntimeInitWrapper PROC
	; RCX, RDX, R8, and R9 
	mov rax, RuntimeInitWrapperExport
	jmp RuntimeInit
RuntimeInitWrapper ENDP

RuntimeCloseWrapper PROC
	mov rax, RuntimeCloseWrapperExport
	jmp RuntimeClose
RuntimeCloseWrapper ENDP

RuntimeMainWrapper PROC
	mov rax, RuntimeMainWrapperExport
	jmp RuntimeMain
RuntimeMainWrapper ENDP

loader ENDS

END